Subject: Re: [PATCH v3] ci: run `make sparse` as part of the GitHub workflow

From: Junio C Hamano <[email-masked]>
Date: Mon, 26 Jul 2021 15:20:17 -0700

"Johannes Schindelin via GitGitGadget" <[email-masked]>
writes:

> From: Johannes Schindelin <[email-masked]>
>
> Occasionally we receive reviews after patches were integrated, where
> `sparse` (https://sparse.docs.kernel.org/en/latest/ has more information
> on that project) identified problems such as file-local variables or
> functions being declared as global.
>
> By running `sparse` as part of our Continuous Integration, we can catch
> such things much earlier. Even better: developers who activated GitHub
> Actions on their forks can catch such issues before even sending their
> patches to the Git mailing list.
>
> This addresses https://github.com/gitgitgadget/git/issues/345
>
> Note: Not even Ubuntu 20.04 ships with a new enough version of `sparse`
> to accommodate Git's needs. The symptom looks like this:
>
>     add-interactive.c:537:51: error: Using plain integer as NULL pointer
>
> To counter that, we download and install the custom-built `sparse`
> package from the Azure Pipeline that we specifically created to address
> this issue.
>
> Helped-by: Jeff King <[email-masked]>
> Signed-off-by: Johannes Schindelin <[email-masked]>
> ---

OK, this is with Peff's "oh, we need 'apt-get update' to avoid stale
package list" fix already rolled in?  It seems you took both of them,
and they look good to me, too.

Unfortunately, ci-make-sparse has already been in 'next' for the
past week or so, so incrementals are vastly preferred.

Let me squish in your "Acked-by" to both of Peff's patches and queue
them on top of js/ci-make-sparse topic.

Thanks.